//---------------------------------------------------------------------------
#define NO_WIN32_LEAN_AND_MEAN

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "shlobj.h"

#define IMAGE_LENGTH 300

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   Panel1->DoubleBuffered=true;
   Image1->Width=IMAGE_LENGTH;
   Image1->Height=IMAGE_LENGTH;
   Panel1->Width=Image1->Width+2*2;
   Panel1->Height=Image1->Height+2*2;
   Image1->Left=2;
   Image1->Top=2;
   Image1->Stretch=true;

   ZeroMemory(gwszFilename, FILENAME_SIZE*sizeof(wchar_t));
}
__fastcall TForm1::~TForm1()
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetDesktopWallpaper(wchar_t *wszFilename, int iOption)
{
   HRESULT hr=S_FALSE;
   IActiveDesktop *pActiveDesktop=NULL;
   WALLPAPEROPT WallpaperOpt;

   hr=CoInitialize(NULL);
   if(SUCCEEDED(hr))
   {
      hr=CoCreateInstance(::CLSID_ActiveDesktop, NULL, CLSCTX_INPROC_SERVER,
         IID_IActiveDesktop, (void**)&pActiveDesktop);
      if(SUCCEEDED(hr))
      {
         pActiveDesktop->SetWallpaper(wszFilename, 0);
         ZeroMemory(&WallpaperOpt, sizeof(WALLPAPEROPT));
         WallpaperOpt.dwSize=sizeof(WALLPAPEROPT);
         switch(iOption)
         {
            case 0:
               WallpaperOpt.dwStyle=WPSTYLE_CENTER;
               break;
            case 1:
               WallpaperOpt.dwStyle=WPSTYLE_TILE;
               break;
            case 2:
               WallpaperOpt.dwStyle=WPSTYLE_STRETCH;
               break;
            default:
               WallpaperOpt.dwStyle=WPSTYLE_CENTER;
               break;
         }
         pActiveDesktop->SetWallpaperOptions(&WallpaperOpt, 0);
         pActiveDesktop->ApplyChanges(AD_APPLY_ALL);

         pActiveDesktop->Release();
      }
      CoUninitialize();
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   ZeroMemory(gwszFilename, FILENAME_SIZE*sizeof(wchar_t));
   if(OpenPictureDialog1->Execute() && FileExists(OpenPictureDialog1->FileName))
   {
      OpenPictureDialog1->FileName.WideChar(gwszFilename, FILENAME_SIZE);
      Graphics::TBitmap *bmp=new Graphics::TBitmap;
      bmp->LoadFromFile(OpenPictureDialog1->FileName);
      if(bmp->Width>=bmp->Height)
      {
         Image1->Width=IMAGE_LENGTH;
         Image1->Height=(int)((double)IMAGE_LENGTH*(double)bmp->Height/(double)bmp->Width);
      }
      else
      {
         Image1->Height=IMAGE_LENGTH;
         Image1->Width=(int)((double)IMAGE_LENGTH*(double)bmp->Width/(double)bmp->Height);
      }
      Image1->Left=(Panel1->Width-Image1->Width)/2;
      Image1->Top=(Panel1->Height-Image1->Height)/2;
      Image1->Picture->Bitmap->Assign(bmp);
      delete bmp;
   }
   else
   {
      Image1->Picture=NULL;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   Image1->Picture=NULL;
   ZeroMemory(gwszFilename, FILENAME_SIZE*sizeof(wchar_t));
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
   SetDesktopWallpaper(gwszFilename, ComboBox1->ItemIndex);
}
//---------------------------------------------------------------------------

